/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jpolycipher.cipher;

/**
 *
 * @author Abdul Fatir
 */
public class PolyalphabeticCipher {

    private final String DEFAULT_KEY = "a";
    private String input_data;
    private String KEY;

    public PolyalphabeticCipher(String input_data, String KEY) {
         
            this.input_data = input_data.toLowerCase();
            this.KEY = KEY.toLowerCase();
        
    }

    public PolyalphabeticCipher(String input_data) {
        this.input_data = input_data.toLowerCase();
        this.KEY = DEFAULT_KEY;
    }

    public void setInput_data(String input_data) {
        this.input_data = input_data.toLowerCase();
    }

    public void setKEY(String KEY) {
        this.KEY = KEY.toLowerCase();
    }

    public String Encrypt() {
        String encrypted_data = "";
        int key_index = 0;
        int shift = 0;
        for (int l = 0; l < input_data.length(); l++) {
            if (key_index == KEY.length()) {
                key_index = 0;
            }
            shift = getAlphaNumber(KEY.charAt(key_index));
            encrypted_data += encode(input_data.charAt(l), shift);
            key_index++;
        }

        return encrypted_data;
    }

    public String Decrypt() {
        String decrypted_data = "";
        int key_index = 0;
        int shift = 0;
        for (int l = 0; l < input_data.length(); l++) {
            if (key_index == KEY.length()) {
                key_index = 0;
            }
            shift = getAlphaNumber(KEY.charAt(key_index));
            decrypted_data += decode(input_data.charAt(l), shift);
            key_index++;
        }
        return decrypted_data;
    }

    private int getAlphaNumber(char alpha) {
        int ASCII = (int) alpha;
        return (ASCII - 96);
    }

    private char encode(char ch, int shift) {
        char encoded;
        int _tmp = (int) ch;
        if (_tmp + shift <= 122) {
            encoded = (char) (_tmp + shift);
        } else {
            shift = _tmp + shift - 122;
            encoded = (char) (96 + shift);
        }
        return encoded;

    }

    private char decode(char ch, int shift) {
        char decoded;
        int _tmp = (int) ch;
        if (_tmp - shift >= 97) {
            decoded = (char) (_tmp - shift);
        } else {
            shift = 97 - (_tmp - shift);
            decoded = (char) (123 - shift);
        }
        return decoded;

    }

   
}
